(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('marked'), require('rxjs'), require('rxjs/operators'), require('@angular/core'), require('@angular/http'), require('prismjs'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define(['exports', 'marked', 'rxjs', 'rxjs/operators', '@angular/core', '@angular/http', 'prismjs', '@angular/common'], factory) :
    (factory((global.nt = global.nt || {}, global.nt.pro = global.nt.pro || {}, global.nt.pro['markdown-block'] = {}),global.marked,global.Rx,global.Rx.operators,global.ng.core,global.ng.http,global.Prism,global.ng.common));
}(this, (function (exports,marked,rxjs,operators,core,http,prismjs,common) { 'use strict';

    marked = marked && marked.hasOwnProperty('default') ? marked['default'] : marked;

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // function clearHTML(text: string) {
    //   return text.replace('', '');
    // }
    var NtMarkdownService = /** @class */ (function () {
        function NtMarkdownService(http$$1) {
            this.http = http$$1;
            this._renderer = new marked.Renderer();
            this.extendRenderer();
            this.setMarkedOptions({});
        }
        // get the content from remote resource
        // get the content from remote resource
        /**
         * @param {?} path
         * @return {?}
         */
        NtMarkdownService.prototype.getContent = 
        // get the content from remote resource
        /**
         * @param {?} path
         * @return {?}
         */
        function (path) {
            return this.http.get(path)
                .pipe(operators.map(this.extractData), operators.catchError(this.handleError));
        };
        Object.defineProperty(NtMarkdownService.prototype, "renderer", {
            get: /**
             * @return {?}
             */
            function () {
                return this._renderer;
            },
            enumerable: true,
            configurable: true
        });
        // handle data
        // handle data
        /**
         * @param {?} res
         * @return {?}
         */
        NtMarkdownService.prototype.extractData = 
        // handle data
        /**
         * @param {?} res
         * @return {?}
         */
        function (res) {
            return res.text() || '';
        };
        /**
         * @param {?} options
         * @return {?}
         */
        NtMarkdownService.prototype.setMarkedOptions = /**
         * @param {?} options
         * @return {?}
         */
        function (options) {
            options = Object.assign({
                gfm: true,
                tables: true,
                breaks: false,
                pedantic: false,
                sanitize: false,
                smartLists: true,
                smartypants: false
            }, options);
            options.renderer = this._renderer;
            marked.setOptions(options);
        };
        // comple markdown to html
        // comple markdown to html
        /**
         * @param {?} data
         * @return {?}
         */
        NtMarkdownService.prototype.compile = 
        // comple markdown to html
        /**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            return marked(data);
        };
        // handle error
        // handle error
        /**
         * @private
         * @param {?} error
         * @return {?}
         */
        NtMarkdownService.prototype.handleError = 
        // handle error
        /**
         * @private
         * @param {?} error
         * @return {?}
         */
        function (error) {
            /** @type {?} */
            var errMsg;
            if (error instanceof http.Response) {
                /** @type {?} */
                var body = error.json() || '';
                /** @type {?} */
                var err = body.error || JSON.stringify(body);
                errMsg = error.status + " - " + (error.statusText || '') + " " + err;
            }
            else {
                errMsg = error.message ? error.message : error.toString();
            }
            return rxjs.Observable.throw(errMsg);
        };
        // extend marked render to support todo checkbox
        // extend marked render to support todo checkbox
        /**
         * @private
         * @return {?}
         */
        NtMarkdownService.prototype.extendRenderer = 
        // extend marked render to support todo checkbox
        /**
         * @private
         * @return {?}
         */
        function () {
            // this._renderer.image = function (href: string, title: string, text: string) {
            // 	return `<img href="${href}" alt="${title}">`;
            // };
            this._renderer.heading = (/**
             * @param {?} text
             * @param {?} level
             * @return {?}
             */
            function (text, level) {
                text = text.trim();
                return "<h" + level + " id=\"" + text.replace(/\<a[^>]*?\>((.|\n)*?)\<\/a\>/g, '$1').replace(/ +/g, '-') + "\">\n\t\t\t\t\t\t" + text + "\n\t\t\t\t\t</h" + level + ">";
            });
            this._renderer.listitem = (/**
             * @param {?} text
             * @return {?}
             */
            function (text) {
                if (/^\s*\[[x ]\]\s*/.test(text)) {
                    text = text
                        .replace(/^\s*\[ \]\s*/, '<input type="checkbox" style=" vertical-align: middle; margin: 0 0.2em 0.25em -1.6em; font-size: 16px; " disabled> ')
                        .replace(/^\s*\[x\]\s*/, '<input type="checkbox" style=" vertical-align: middle; margin: 0 0.2em 0.25em -1.6em; font-size: 16px; " checked disabled> ');
                    return "<li style=\"list-style: none\">" + text + "</li>";
                }
                else {
                    return "<li>" + text + "</li>";
                }
            });
        };
        NtMarkdownService.decorators = [
            { type: core.Injectable },
        ];
        /** @nocollapse */
        NtMarkdownService.ctorParameters = function () { return [
            { type: http.Http }
        ]; };
        return NtMarkdownService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtMarkdownBlockComponent = /** @class */ (function () {
        function NtMarkdownBlockComponent(_platformId, _markdownService, _elementRef) {
            this._platformId = _platformId;
            this._markdownService = _markdownService;
            this._elementRef = _elementRef;
            this.changeLog = [];
        }
        /**
         * @return {?}
         */
        NtMarkdownBlockComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.markdown = this._markdownService.compile(this._data);
        };
        /**
         * @return {?}
         */
        NtMarkdownBlockComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
        function () {
        };
        Object.defineProperty(NtMarkdownBlockComponent.prototype, "path", {
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (this._path = value || '') {
                    this.onPathChange();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtMarkdownBlockComponent.prototype, "data", {
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (this._data = value || '') {
                    this.onDataChange(value);
                }
            },
            enumerable: true,
            configurable: true
        });
        // on input
        // on input
        /**
         * @param {?} data
         * @return {?}
         */
        NtMarkdownBlockComponent.prototype.onDataChange = 
        // on input
        /**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            if (data) {
                this._elementRef.nativeElement.innerHTML = this._markdownService.compile(data);
            }
            else {
                this._elementRef.nativeElement.innerHTML = '';
            }
            this.postpare();
        };
        /**
         *  After view init
         */
        /**
         *  After view init
         * @return {?}
         */
        NtMarkdownBlockComponent.prototype.ngAfterViewInit = /**
         *  After view init
         * @return {?}
         */
        function () {
            if (this._path) {
                this.onPathChange();
            }
            else if (!this._data) {
                this.processRaw();
            }
        };
        /**
         * @return {?}
         */
        NtMarkdownBlockComponent.prototype.processRaw = /**
         * @return {?}
         */
        function () {
            this._md = this.prepare(this._elementRef.nativeElement.innerHTML);
            this._elementRef.nativeElement.innerHTML = this._markdownService.compile(this._md);
            this.postpare();
        };
        /**
         * get remote conent;
         */
        /**
         * get remote conent;
         * @return {?}
         */
        NtMarkdownBlockComponent.prototype.onPathChange = /**
         * get remote conent;
         * @return {?}
         */
        function () {
            var _this = this;
            this._ext = this._path && this._path.split('.').splice(-1).join();
            this._markdownService.getContent(this._path)
                .subscribe((/**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                _this._md = _this._ext !== 'md' ? '```' + _this._ext + '\n' + data + '\n```' : data;
                _this._elementRef.nativeElement.innerHTML = _this._markdownService.compile(_this.prepare(_this._md));
                _this.postpare();
            }), (/**
             * @return {?}
             */
            function () { return _this._handleError; }));
        };
        /**
         * catch http error
         */
        /**
         * catch http error
         * @private
         * @param {?} error
         * @return {?}
         */
        NtMarkdownBlockComponent.prototype._handleError = /**
         * catch http error
         * @private
         * @param {?} error
         * @return {?}
         */
        function (error) {
            return Promise.reject(error.message || error);
        };
        /**
         * Prepare string
         */
        /**
         * Prepare string
         * @param {?} raw
         * @return {?}
         */
        NtMarkdownBlockComponent.prototype.prepare = /**
         * Prepare string
         * @param {?} raw
         * @return {?}
         */
        function (raw) {
            var _this = this;
            if (!raw) {
                return '';
            }
            if (this._ext === 'md' || !this.path) {
                /** @type {?} */
                var isCodeBlock_1 = false;
                return raw.split('\n').map((/**
                 * @param {?} line
                 * @return {?}
                 */
                function (line) {
                    if (_this._trimLeft(line).substring(0, 3) === "```") {
                        isCodeBlock_1 = !isCodeBlock_1;
                    }
                    return isCodeBlock_1 ? line : line.trim();
                })).join('\n');
            }
            return raw.replace(/\"/g, '\'');
        };
        /**
         * @return {?}
         */
        NtMarkdownBlockComponent.prototype.postpare = /**
         * @return {?}
         */
        function () {
            // 判断是否是浏览器执行，如果是：增加代码高亮
            typeof prismjs.highlightAll === 'function'
                && common.isPlatformBrowser(this._platformId)
                && prismjs.highlightAll(false);
        };
        /**
         * Trim left whitespace
         */
        /**
         * Trim left whitespace
         * @private
         * @param {?} line
         * @return {?}
         */
        NtMarkdownBlockComponent.prototype._trimLeft = /**
         * Trim left whitespace
         * @private
         * @param {?} line
         * @return {?}
         */
        function (line) {
            return line.replace(/^\s+|\s+$/g, '');
        };
        NtMarkdownBlockComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-markdown-block, [nt-markdown-block]',
                        template: '<div [innerHtml]="markdown"></div>',
                        encapsulation: core.ViewEncapsulation.None,
                        host: {
                            class: 'nt-markdown-block'
                        }
                    },] },
        ];
        /** @nocollapse */
        NtMarkdownBlockComponent.ctorParameters = function () { return [
            { type: Object, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] }] },
            { type: NtMarkdownService },
            { type: core.ElementRef }
        ]; };
        NtMarkdownBlockComponent.propDecorators = {
            path: [{ type: core.Input }],
            data: [{ type: core.Input }]
        };
        return NtMarkdownBlockComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtMarkdownBlockModule = /** @class */ (function () {
        function NtMarkdownBlockModule() {
        }
        NtMarkdownBlockModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, http.HttpModule],
                        declarations: [NtMarkdownBlockComponent],
                        providers: [NtMarkdownService],
                        exports: [NtMarkdownBlockComponent],
                        entryComponents: [NtMarkdownBlockComponent]
                    },] },
        ];
        return NtMarkdownBlockModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NtMarkdownBlockModule = NtMarkdownBlockModule;
    exports.NtMarkdownBlockComponent = NtMarkdownBlockComponent;
    exports.NtMarkdownService = NtMarkdownService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=markdown-block.umd.js.map
