import 'codemirror/mode/gfm/gfm';
import 'codemirror/addon/display/placeholder';
import 'codemirror/addon/edit/continuelist';
import { EditorFromTextArea } from 'codemirror';
import { ElementRef, OnChanges, OnDestroy, Renderer2, SimpleChanges } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
import { NtFormFieldControl } from '@ng-tangram/components/forms';
import { NtMarkdownEditorConfig } from './markdown-editor-config';
import { NtMarkdownEditorIcons } from './markdown-editor-icons';
export declare class NtMarkdownEditorComponent extends NtFormFieldControl<string> implements ControlValueAccessor, OnChanges, OnDestroy {
    private _renderer;
    ngControl: NgControl;
    private platformId;
    icons: NtMarkdownEditorIcons;
    private readonly _destroy;
    private _value;
    previewMode: boolean;
    instance: EditorFromTextArea;
    config: NtMarkdownEditorConfig;
    activeActions: string[];
    activeActionsSnapshot: string[];
    editor: ElementRef;
    value: string;
    readonly empty: boolean;
    private _focused;
    readonly focused: boolean;
    placeholder: string;
    private _disabled;
    disabled: boolean;
    private _required;
    required: boolean;
    private _minRows;
    minRows: number;
    private _maxRows;
    maxRows: number;
    readonly history: {
        undo: number;
        redo: number;
    };
    private _onChange;
    private _onTouched;
    constructor(_renderer: Renderer2, ngControl: NgControl, platformId: Object, icons: NtMarkdownEditorIcons);
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    writeValue(value: any): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    focus(): void;
    setDisabledState(isDisabled: boolean): void;
    execCommand(type: string): void;
    undo(): void;
    redo(): void;
    private _codeMirrorInit;
    private _onCodeMirrorChange;
    private _onCodeMirrorCursorActivity;
    private _onCodeMirrorFocus;
    private _onCodeMirrorBlur;
    private _actionMatches;
    /**
     * 以文本行数来计算输入窗口的高度。
     */
    private _setEditorHeightRange;
}
